import java.io.*;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.program.*;
import javax.xml.parsers.*;

import org.w3c.dom.*;

/**
 * @author Softbank Publishing Inc.
 * Standard SWT SKELTON TEMPLATE ver1.0
 */
public class CdLauncher {

	private Display display;
	private Shell shell;

	/**
	 * `̃C[`
	 */
	public void graphicmain(String fileName) throws Exception {

		//XML̃[g擾
		Element root = getRoot(fileName);

		//^CgƃC[W擾
		String windowTitle = root.getAttribute("windowtitle");
		String topimageUrl = root.getAttribute("topimageUrl");

		//EBhȄ
		display = new Display();
		shell = new Shell(display);
		shell.setText(windowTitle);
		RowLayout layout = new RowLayout(SWT.VERTICAL);
		shell.setLayout(layout);

		//^Cg摜x̍쐬
		Image image1 = new Image(display, topimageUrl);
		Label label = new Label(shell, SWT.BORDER);
		label.setImage(image1);

		//{^쐬B
		//{^ɂXMLǂݍ񂾁ANƃeLXgt
		NodeList list = root.getElementsByTagName("button");

		for (int i = 0; i < list.getLength(); i++) {

			Element element = (Element) list.item(i);
			String title = getChildValue(element, "title");
			String filelink = getChildValue(element, "filelink");

			setButton(filelink, title);
		}

		//ł܂Ƃ߂ĕ`
		shell.pack();
		shell.open();

		//Cxg[v
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}

		display.dispose();
	}

	/**
	 * XMLt@C̃hLg̃[g擾܂B
	 * @param fileName t@C
	 * @return [g
	 */
	private Element getRoot(String fileName) throws Exception {

		DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;

		builder = dbfactory.newDocumentBuilder();

		Document doc = builder.parse(new File(fileName));
		Element root = doc.getDocumentElement();
		return root;

	}

	/**
	 * qvf̍ŏ̃eLXg̒l擾B
	 * @param element
	 * @param name
	 * @return
	 */
	private String getChildValue(Element element, String name) {

		NodeList nodeList = element.getElementsByTagName(name);
		Element titleElement = (Element) nodeList.item(0);
		String text = titleElement.getFirstChild().getNodeValue();
		return text;
	}

	/**
	 * @param execScriptUrl sWindowsp̃XNvgURL
	 * @param text button̕
	 */
	private void setButton(final String execScriptUrl, String text) {

		SelectionListener listener = new SelectionAdapter() {

			public void widgetDefaultSelected(SelectionEvent event) {
			}
			public void widgetSelected(SelectionEvent event) {
				Program.launch(execScriptUrl);
			}

		};

		Button button = new Button(shell, SWT.BUTTON3);
		button.setText(text);
		button.setLayoutData(new RowData(400, 30));
		button.addSelectionListener(listener);
	}

	/**
	 * C\bh
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			System.err.println("LȈ(.xmlt@C)w肵ĂB");
			System.exit(-1);
		}

		new CdLauncher().graphicmain(args[0]);
	}

}
